#version 330 core
out vec4 FragColor;

in vec2 TexCoords;

uniform sampler2D scene;
uniform sampler2D bloomBlur;
uniform bool bloom;
uniform float exposure;

void main()
{           
	
	// read color values from the textures and blend additively
    vec3 finalColor = texture(scene, TexCoords).rgb;      
    vec3 bloomColor = texture(bloomBlur, TexCoords).rgb;
    if(bloom)
        finalColor += (0.15) * bloomColor;
   
   // the following code gave weird results in our case, which is why we left it out in the end:

   // tone mapping using exposure
   // finalColor = vec3(1.0) - exp(-finalColor * exposure);

	// reinhard tone mapping
	// finalColor = (finalColor + vec3(1.0));

	// gamma correction
    // float gamma = 2.2;      
    // finalColor = pow(finalColor, vec3(1.0 / gamma));

    FragColor = vec4(finalColor, 1.0);
}