#version 330 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 tex_coords;
layout (location = 3) in vec3 tangent;

out vec3 Frag_pos;
out vec2 Tex_Coords;
out	mat3 TBN;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

void main()
{
	
	vec3 T = normalize(vec3(model * vec4(tangent,   0.0)));
    vec3 N = normalize(vec3(model * vec4(normal,  0.0)));
	vec3 B = cross(T,N);
	T= normalize(T- dot(T,N) * N);
	TBN = mat3(T, B, N);

	Tex_Coords = tex_coords;
  
	Frag_pos = vec3(model * vec4(position, 1.0));
	gl_Position = projection * view * vec4(Frag_pos, 1.0);
}